diff --git a/src/backend/libpq/auth.c b/src/backend/libpq/auth.c
index 8fa9aa7..d86f238 100644
--- a/src/backend/libpq/auth.c
+++ b/src/backend/libpq/auth.c
@@ -2022,7 +2022,11 @@ CheckLDAPAuth(Port *port)
 			ereport(LOG,
 					(errmsg("could not search LDAP for filter \"%s\" on server \"%s\": %s",
 						filter, port->hba->ldapserver, ldap_err2string(r))));
+			ereport(LOG,
+					(errmsg("additional LDAP error information: %s",
+							ldap_err2string(ldap_result2error(ldap, search_message, 0)))));
 			pfree(filter);
+			ldap_msgfree(search_message);
 			return STATUS_ERROR;
 		}
 
